;
; ==================================================
;
;   Auto_350.asm     Auto Test Software  
;                                 
;   Version:         1.0   Released 03/03/2005
;   Author:          Gary Karnes 
;   Compiler:        As12
;   Platform:        HCS12
;   Purpose:         Test DEMO9S12XDT512   
;   
; ==================================================
;
;  
;**************
;   EQUATES   *
;**************
RamSt:        equ     $2000   ; start of ram used
RamEnd:       equ     $3FFF   ; End of Ram
RamLen:       equ     $2000   ; 8k ram
PrgSt:        equ     $C000   ; Flash Program

;*******************
;   INCLUDE FILES
;*******************

      include        H12xEqu.asm     ; include register equates

;
;**********************
; Program starts here *
;**********************
; If loading to Ram, uncomment the following line

;         org     RamSt
          org     $2000        

START:

; If programming to Flash, uncomment the following line
         lds     #RamEnd+1   ; Load Stack pointer

         include    Setup350.asm     ; Include Setup

Menu:

	 jsr   M_CRLF	     ; output carriage-return
       jsr   M_CRLF
       jsr   M_CRLF
       jsr   M_CRLF
       jsr   String2
       fdb   MAXIOM           ; Axiom
       fdb   MMANUFAC         ; MANUFACTURING
       jsr   M_CRLF
       jsr   String2
       fdb   MDEMO9SX         ; DEMO9S12XDT512
       fdb   MTest            ; Test
       jsr   M_CRLF
       jsr   M_CRLF
       jsr   String3          ; 1. CAN
       fdb   M1.
       fdb   MCAN
       fdb   MSpace2

       jsr   String3          ; 2. LEDS
       fdb   M2.
       fdb   MLEDS
       fdb   MSpace2

       jsr   String3          ; 3. LIN
       fdb   M3.
       fdb   MLIN
       fdb   MSpace2

       jsr   String3          ; 4. RV1
       fdb   M4.
       fdb   MRV1
       fdb   MSpace2

       jsr   String3          ; 5. RZ1
       fdb   M5.
       fdb   MRZ1
       fdb   MSpace2

       jsr   M_CRLF
       jsr   M_CRLF

       jsr   String3          ; 6. Switches
       fdb   M6.
       fdb   MSwitchs
       fdb   MSpace2

       jsr   String3          ; 7. J1
       fdb   M7.
       fdb   MJ1
       fdb   MSpace2

       jsr   String3          ; 8. J2
       fdb   M8.
       fdb   MJ2
       fdb   MSpace2

       jsr   M_CRLF

       jsr   Sci_In          ; wait for operator

       cmpa   #'1'           ; Select Can / LIN test
       lbeq   CANLIN         ; do LEDS test

       cmpa   #'2'           ; Selection 2
       lbeq   LEDS_Tst       ; do LEDS Test
 
       cmpa   #'3'           ; Selection 3
       lbeq   LIN_Tst        ; do LIN Test

       cmpa   #'4'           ; Selection 4
       lbeq   RV1_Tst        ; do RV1 Test

       cmpa   #'5'           ; Selection 5
       lbeq   RZ1_Tst        ; do RZ1 Test

       cmpa   #'6'           ; Selection 6
       lbeq   SW_350         ; do SW3 Test

       cmpa   #'7'           ; Selection 7
       lbeq   J1_350         ; do J1 Test

       cmpa   #'8'           ; Selection 8
       lbeq   J2_350         ; do J2 Test

      lbra  Menu             ; return to menu  
;


; Output a Carriage return and a line feed.  Returns a = cr.
OUTCRLF:
        LDAA #$0A       ; get LF
	JSR  Sci_Out	; send it
	LDAA #$0D	; get CR
	JSR  Sci_Out	; send it
        LDAA #$00
	JSR  Sci_Out	; output padding
	LDAA #$0D
	RTS

     include       Mes_350.asm         ; include messages
     include      Strg_350.asm         ; string driver
     include      Anal_350.asm         ; analog routines
     include       SCI_350.asm         ; SCI control
     include      LEDS_350.asm         ; LEDS test
     include        SW_350.asm         ; Switches Test
     include       CAN_350.asm         ; CAN test
     include       LIN_350.asm         ; LIN test
     include       Message.asm         ; Message File
     include        SCIout.asm	   ; DT512 SCI routines
     include       RV1_350.asm         ; Test RV1
     include       Del_350.asm         ; delay routines
     include       RZ1_350.asm         ; Test RZ1
     include        J1_350.asm         ; Test J1
     include        J2_350.asm         ; Test J2

;


         END
