;
; ======================================================
;
;   Sci_350.asm		Sci Control
;
;   Version:		1.0   12/12/04
;   Author:		      Gary Karnes
;   Compiler:		AS12
;
;   Platform:		DEMO9SXDT512
;   Purpose:		Sci Interface
; ======================================================
;
; Setup communication ports.
; Initialize SCI0 for 9600 baud
; Using a 4 MHz clock, the Baud rate register value is
; calculated as follows:
;	BR = MCLK / (16 * Baud_Rate)
;	MCLK = crystal / 2
;	BR = 2,000,000 / (16 * 9600)
;	BR = 13 => 0D hex
; $0D = 9600 baud

TDRE: 	equ $80	; TX Data Reg Empty
TC:   	equ $40	; Tx Complete Flag
RDRF: 	equ $20	; Rx Data Reg Full




;
Init_Sci:

	clr SCI0BDH		; clear high baud com 1
	movb #$0D,SCI0BDL	; store low baud rate com 1
	clr SCI0CR1
	movb #$0c,SCI0CR2	; enable tx & rx, no ints on com1
      rts
;
;

Sci_In:
		
	brclr SCI0SR1,#RDRF,Sci_In	; loop until input avail
	ldaa SCI0DRL		; get input data
      rts
;
;
Sci_Out:	

	brclr SCI0SR1,#$80,Sci_Out	; loop until TDRE bit set
	staa SCI0DRL	; send character
	rts
;
;



