;
; ===================================================
;
;   SW_350.asm		SW1, SW2 and SW3 Test
;
;   Version:		1.0   01/14/05
;   Author:		      Gary Karnes
;   Compiler:		AS12
;
;   Platform:		DEMO9S12XDT512
;   Purpose:		Test operation of Switches
; ====================================================
;


SW1:     equ $01			; SW1 Mask
SW2:     equ $02			; SW2 Mask
SW31:	   equ $01			; SW3 pos 1 mask
SW32:	   equ $02			; SW3 pos 2 mask
SW33:    equ $04			; SW3 pos 3 mask
SW34:	   equ $08			; SW3 pos 4 mask

PTBDIR:	equ $F0		; PTB[7:4] out,PTB[3:0] in
PTBPUL:	equ $02		; PTB pull enable
PTPPUL:	equ $03		; PTP pull enable [1:0]
PTPPOL:	equ $00		; PTP polarity fall edge



SW_350:

      movb  #PTBPUL,PUCR	; PULLB enable
	movb  #PTBDIR,DDRB	; 7-4 out, 3-0 in

	movb  #PTPPUL,PERP	; pull en PP0,PP1
	movb  #PTPPOL,PPSP	; fall edge polarity

	movb  #$E0,PORTB		; init PTB

      jsr   M_CRLF
      jsr   M_CRLF
      jsr   String2
      fdb   MSwitchs            ; Switches
      fdb   MTest               ; Test

; Start Check SW1 Switch
; Check if SW1 & SW2 are not pressed

	brset PTP,#SW1+SW2,SW1_N	; SW1 not pressed
      lbra  Failed              ; report fail
 
; Press SW1

SW1_N:

      jsr   M_CRLF
      jsr   M_CRLF

      jsr   String2
      fdb   MPress            ; Press
      fdb   MSW1              ; SW1

SW_SW1_W:

      brset PTP,#SW1,SW_SW1_W	; Wait for key press

; Press SW2

SW2_N:

      jsr   M_CRLF
      jsr   M_CRLF

      jsr   String2
      fdb   MPress            ; Press
      fdb   MSW2              ; SW2

SW_SW2_W:

      brset PTP,#SW2,SW_SW2_W       ; Wait for key press
;
;..........................................................

;
; Check SW3

      jsr   M_CRLF
      jsr   M_CRLF

      jsr   String3
      fdb   MTurn          ; Turn
      fdb   MSW3           ; SW3
      fdb   MOff           ; Off

      jsr   PKEY           ; press any key to continue

      brset PORTB,#SW31+SW32+SW33+SW34,SW_SW3_N ; Wait for key press
      lbra  Failed         ; report fail

; Check SW3 position 1	

SW_SW3_N:       

      jsr   M_CRLF
      jsr   M_CRLF
      jsr   String3
      fdb   MTurn          ; Turn
      fdb   MSW3           ; SW3
      fdb   MPosit         ; Position

      
      jsr   String2
      fdb   MOne           ; One
      fdb   MOn            ; On
 
SW_L1:     

      brset PORTB,#SW31,SW_L1 ; Wait for key press

; Check SW3 position 2
      jsr   M_CRLF
      jsr   M_CRLF
      jsr   String3
      fdb   MTurn          ; Turn
      fdb   MSW3           ; SW3
      fdb   MPosit         ; Position

      
      jsr   String2
      fdb   MTwo           ; Two
      fdb   MOn            ; On

SW_L2: 
    
      brset PORTB,#SW32,SW_L2 ; Wait for key press	

;
; Check SW3 position 3

      jsr   M_CRLF
      jsr   M_CRLF
      jsr   String3
      fdb   MTurn          ; Turn
      fdb   MSW3           ; SW3
      fdb   MPosit         ; Position

      
      jsr   String2
      fdb   MThree         ; Three
      fdb   MOn            ; On

SW_L3:  
   
      brset PORTB,#SW33,SW_L3 ; Wait for key press	

; Check SW3 position 4

      jsr   M_CRLF
      jsr   M_CRLF
      jsr   String3
      fdb   MTurn          ; Turn
      fdb   MSW3           ; SW3
      fdb   MPosit         ; Position

      
      jsr   String2
      fdb   MFour          ; Four
      fdb   MOn            ; On

SW_L4: 
    
      brset PORTB,#SW34,SW_L4 ; Wait for key press	





          lbra  Menu       ; return to menu  

; ========== SUB-ROUTINES ============================

DELAYT:

	psha			; store A
	pshx			; store X

	ldaa #$02		; outer loop count
DLYOT:
	ldx #$FFFF		; inner loop count

DLYI_L:

 	dex			; X = X-1
	bne DLYI_L		; inner delay loop
	deca
	bne DLYOT		; outer delay loop

	pulx			; restore X
	pula			; restore A

	rts			; return

;
;
;
;

